package com.esk.deob;

import org.objectweb.asm.Opcodes;
import org.objectweb.asm.tree.*;

import com.esk.tree.FieldHandle;
import com.esk.tree.VisitorAdapter;

public abstract class Transform extends VisitorAdapter implements Opcodes {
  private ClassNode[] cns;

  public abstract void printResult();

  public void visitClasses(ClassNode[] cns) {
    this.cns = cns;
  }

  public ClassNode clss(String n) {
    for(ClassNode cn : cns)
      if(cn.name.equals(n))
        return cn;
    return null;
  }

  public FieldHandle field(FieldInsnNode fi) {
    return field(fi.owner, fi.name);
  }

  public FieldHandle field(String o, String n) {
    return field(clss(o), n);
  }

  @SuppressWarnings("unchecked")
  public FieldHandle field(ClassNode o, String n) {
    for(FieldNode fn : (java.util.List<FieldNode>)o.fields)
      if(fn.name.equals(n))
        return new FieldHandle(o, fn);
    return null;
  }

  public abstract boolean accept(ClassNode cn);

  public abstract boolean accept(MethodNode mn);
}