package com.esk.deob.impl;

import org.objectweb.asm.tree.*;

import com.esk.deob.Transform;
import com.esk.tree.FieldHandle;
import com.esk.tree.Node;

public class ControlFieldFinder extends Transform {
  private ClassNode cn;
  public FieldHandle cf;

  public void printResult() { }

  public void visitVar(Node n) {
    if(n.op() != ISTORE)
      return;
    Node p = n.producing()[0];
    if(p.op() != GETSTATIC)
      return;
    FieldHandle cf = field(cn, ((FieldInsnNode)p.insn()).name);
    String d = cf.field().desc;
    if(!d.equals("Z") && !d.equals("I"))
      return;
    if(this.cf != null && !cf.equals(this.cf))
      throw new RuntimeException("ambiguous control field!");
    this.cf = cf;
  }

  public boolean accept(ClassNode cn) {
    this.cn = cn;
    return cn.name.equals("client");
  }

  public boolean accept(MethodNode mn) {
    return (mn.access & ACC_STATIC) == 0;
  }
}