package com.esk.deob.impl;

import org.objectweb.asm.tree.*;

import com.esk.deob.Transform;
import com.esk.tree.*;

public class FlowRedundancy extends Transform {
  private static int i = 0, j = 0;

  public void printResult() {
    System.out.println("removed " + i + " redundant gotos and " + j + " consecutive returns");
  }

  public void visit(Node n) {
    if(n.op() == RETURN) {
      Node nx = n.next();
      while(nx != null && nx.op() == -1)
        nx = nx.next();
      if(nx == null)
        return;
      if(nx.op() == RETURN) {
        n.delete();
        j++;
      }
    }
  }

  public void visitJump(JumpNode jn) {
    Target t = jn.target();
    Node n = t.resolve();
    if(n.op() == GOTO) {
      jn.setTarget(((JumpNode)n).target());
      if(t.targeters().length == 0) {
        t.delete();
        n.delete();
      }
      i++;
    }
  }

  public boolean accept(ClassNode cn) {
    return true;
  }

  public boolean accept(MethodNode mn) {
    return true;
  }
}