package com.esk.deob.impl;

import org.objectweb.asm.tree.*;

import com.esk.deob.Transform;
import com.esk.tree.*;

public class NotComparison extends Transform {
  private static int i = 0;

  public void printResult() {
    System.out.println("standardized " + i + " xor comparisons");
  }

  public void visitJump(JumpNode jn) {
    Node[] ns = jn.producing();
    if(ns.length == 1) {
      Node n = ns[0];
      if(n.op() != LCMP)
        return;
      stripNot(jn, n);
    } else if(ns.length == 2)
      stripNot(jn, jn);
  }

  private static void stripNot(JumpNode jn, Node n) {
    Node[] ns = n.producing();
    if(ns.length != 2)
      return;
    if(isNot(ns[1]) && ns[0] instanceof NumberNode) {
      jn.reverse();
      n.flip();
    }
    ns = n.producing();
    Node n1 = ns[0], n2 = ns[1];
    if(isNot(n1)) {
      boolean b = isNot(n2);
      if(!b && !(n2 instanceof NumberNode))
        return;
      n1.popTail();
      n.splice(n1);
      if(b) {
        n2.popTail();
        n.splice(n2);
      } else {
        NumberNode nn = (NumberNode)n2;
        Number num = nn.value();
        if(n1.op() == IXOR)
          nn.setValue(~num.intValue());
        else
          nn.setValue(~num.longValue());
      }
      jn.reverse();
      i++;
    }
  }

  public boolean accept(ClassNode cn) {
    return true;
  }

  public boolean accept(MethodNode mn) {
    return true;
  }

  private static boolean isNot(Node n) {
    int o = n.op();
    if(o != IXOR && o != LXOR)
      return false;
    Node t = n.tail();
    if(t instanceof NumberNode)
      return ((NumberNode)t).value().longValue() == -1;
    return false;
  }
}