package com.esk.deob.impl;

import org.objectweb.asm.tree.*;

import com.esk.deob.Transform;
import com.esk.tree.*;

public class OpaquePredicate extends Transform {
  private FieldHandle cf;
  private Node istore;
  private static int i = 0;

  public OpaquePredicate(FieldHandle cf) {
    this.cf = cf;
  }

  public void printResult() {
    System.out.println("removed " + i + " opaque predicates");
  }

  public void visitVar(Node n) {
    if(n.op() == ISTORE) {
      Node[] p = n.producing();
      if(p.length != 1)
        return;
      Node c = p[0];
      if(c.op() != GETSTATIC)
        return;
      if(!((InvocationNode)c).invokes(cf))
        return;
      istore = n;
    }
  }

  public void visitJump(JumpNode n) {
    int op = n.op();
    boolean b = op == IFEQ;
    if(b || op == IFNE) {
      Node[] p = n.producing();
      if(p.length != 1)
        return;
      Node c = p[0];
      op = c.op();
      if(op != ILOAD && op != GETSTATIC)
        return;
      if(op == ILOAD) {
        if(istore == null)
          return;
        if(n.tree() != istore.tree())
          return;
        if(((VarInsnNode)c.insn()).var != ((VarInsnNode)istore.insn()).var)
          return;
        if(istore.owner() != null)
          istore.delete();
      } else if(op == GETSTATIC && !((InvocationNode)c).invokes(cf))
        return;
      if(b) {
        n.clear();
        n.setInsn(new JumpInsnNode(GOTO, n.insn().label));
      } else
        n.delete();
      i++;
    }
  }

  public boolean accept(ClassNode cn) {
    return true;
  }

  public boolean accept(MethodNode mn) {
    return true;
  }
}