package com.esk.deob.impl;

import org.objectweb.asm.tree.*;

import com.esk.deob.Transform;
import com.esk.tree.*;

public class TryCatch extends Transform {
  private static int i = 0;

  public void printResult() {
    System.out.println("removed " + i + " try-catches for the sake of correct flow");
  }

  public void visitVar(Node n) {
    if(!n.h || n.op() != ASTORE)
      return;
    if(n.next() instanceof Target) {
      n.deleteTryCatch();
      i++;
      return;
    }
    Node p = n.previous();
    if(p == null)
      return;
    while(p.op() == -1)
      p = p.previous();
    Node e;
    if(p.op() == GOTO) {
      e = ((JumpNode)p).resolve().previous();
      while(e.op() == -1)
        e = e.previous();
    } else
      e = n.next();
    if(e.op() != ATHROW)
      return;
    n.deleteTryCatch();
    Node c = n;
    while(true) {
      Node _n = c.next();
      c.delete();
      if(c == e)
        break;
      c = _n;
    }
    i++;
  }

  public boolean accept(ClassNode cn) {
    return true;
  }

  public boolean accept(MethodNode mn) {
    return true;
  }
}