package com.esk.tree;

import org.objectweb.asm.tree.*;

public class FieldHandle {
  private ClassNode o;
  private FieldNode fn;

  public FieldHandle(ClassNode o, FieldNode fn) {
    this.o = o;
    this.fn = fn;
  }

  public ClassNode owner() {
    return o;
  }

  public FieldNode field() {
    return fn;
  }

  public String toString() {
    return o.name + "." + fn.name + " " + fn.desc;
  }

  public boolean equals(Object o) {
    if(o instanceof FieldHandle) {
      FieldHandle fh = (FieldHandle)o;
      return fh.o == this.o && fh.fn == fn;
    }
    return false;
  }
}