package com.esk.tree;

import org.objectweb.asm.tree.*;

public class InvocationNode extends Node {
  public InvocationNode(NodeTree t, AbstractInsnNode ai, int c, int p) {
    super(t, ai, c, p);
  }

  public Node[] args() {
    return subList(1).array(Node.class);
  }

  public Node objectref() {
    int o = op();
    return o == INVOKESTATIC || o == INVOKEDYNAMIC ? null : head();
  }

  public boolean invokes(FieldHandle fh) {
    FieldInsnNode fi = (FieldInsnNode)ai;
    if(!fi.owner.equals(fh.owner().name))
      return false;
    FieldNode fn = fh.field();
    return fi.name.equals(fn.name);
  }

  public boolean invokes(MethodHandle mh) {
    MethodInsnNode mi = (MethodInsnNode)ai;
    if(!mi.owner.equals(mh.owner().name))
      return false;
    MethodNode fn = mh.method();
    return mi.name.equals(fn.name) && mi.desc.equals(fn.desc);
  }

  public boolean invokesThis() {
    Node o = objectref();
    if(o == null || o.op() == ALOAD)
      return false;
    return ((VarInsnNode)o.ai).var == 0;
  }
}