package com.esk.tree;

import org.objectweb.asm.tree.*;

public class MethodHandle {
  private ClassNode o;
  private MethodNode mn;

  public MethodHandle(ClassNode o, MethodNode mn) {
    this.o = o;
    this.mn = mn;
  }

  public ClassNode owner() {
    return o;
  }

  public MethodNode method() {
    return mn;
  }

  public String toString() {
    return o.name + "." + mn.name + " " + mn.desc;
  }

  public boolean equals(Object o) {
    if(o instanceof MethodHandle) {
      MethodHandle mh = (MethodHandle)o;
      return mh.o == this.o && mh.mn == mn;
    }
    return false;
  }
}