package com.esk.tree;

import org.objectweb.asm.tree.AbstractInsnNode;
import org.objectweb.asm.tree.InsnNode;

public class ReturnNode extends Node {
  public ReturnNode(NodeTree t, AbstractInsnNode ai, int c, int p) {
    super(t, ai, c, p);
  }

  public static ReturnNode nullReturn(ReturnNode rn) {
    int o = rn.op();
    ReturnNode _rn = new ReturnNode(rn.t, new InsnNode(o), rn.c, rn.p);
    Object r = null;
    switch(o) {
      case IRETURN:
        r = -1;
        break;
      case LRETURN:
        r = -1L;
        break;
      case FRETURN:
        r = -1F;
        break;
      case DRETURN:
        r = -1D;
        break;
      case ARETURN:
        r = new Node(rn.t, new InsnNode(ACONST_NULL), 0, 0);
        break;
    }
    if(r instanceof Number) {
      NumberNode nn = new NumberNode(rn.t, null, 0, 0);
      nn.setValue((Number)r);
      _rn.add(nn);
    } else if(r != null)
      _rn.add((Node)r);
    return _rn;
  }
}