package com.esk.util;

public class Map<K, V> extends List<Map<K, V>.Pair> {
  public void put(K k, V v) {
    add(new Pair(k, v));
  }

  @SuppressWarnings("unchecked")
  public V[] values(Class<V> c) {
    V[] vs = (V[])java.lang.reflect.Array.newInstance(c, size());
    int i = 0;
    for(Pair p : this)
      vs[i++] = p.v;
    return vs;
  }

  public V get(K k) {
    for(Pair p : this)
      if(p.k.equals(k))
        return p.v;
    return null;
  }

  public boolean removeByKey(K k) {
    for(Pair p : this)
      if(p.k.equals(k))
        return remove(p);
    return false;
  }

  public boolean containsKey(K k) {
    for(Pair p : this)
      if(p.k.equals(k))
        return true;
    return false;
  }

  protected class Pair {
    public K k;
    public V v;

    Pair(K k, V v) {
      this.k = k;
      this.v = v;
    }

    public String toString() {
      return "[" + k + "," + v + "]";
    }
  }
}