package com.esk.util;

import java.util.ListIterator;

public class Tree<T extends Tree<T>> extends List<T> {
  private T o;

  public void setOwner(T o) {
    this.o = o;
  }

  public ListIterator<T> listIterator(int index) {
    return new TreeIterator(index);
  }

  public T owner() {
    return o;
  }

  @SuppressWarnings("unchecked")
  public class TreeIterator extends ListIteratorImpl {
    public TreeIterator(int i) {
      super(i);
    }

    public void add(T t) {
      super.add(t);
      t.o = (T)Tree.this;
    }

    public void set(T t) {
      super.set(t);
      t.o = (T)Tree.this;
    }

    public void remove() {
      T t = (T)lastReturned();
      super.remove();
      t.o = null;
    }
  }
}