package com.esk.util;

import static org.objectweb.asm.tree.AbstractInsnNode.*;

import org.objectweb.asm.tree.*;
import org.objectweb.asm.util.AbstractVisitor;

public class Util {
  public static AbstractInsnNode nextReal(AbstractInsnNode ai) {
    while(ai.getOpcode() == -1)
      ai = ai.getNext();
    return ai;
  }

  public static String toString(AbstractInsnNode ai) {
    StringBuilder sb = new StringBuilder();
    int o = ai.getOpcode();
    if(o == -1)
      return ai.toString();
    sb.append(AbstractVisitor.OPCODES[o]);
    int t = ai.getType();
    switch(t) {
      case INT_INSN:
        sb.append(' ');
        sb.append(((IntInsnNode)ai).operand);
        break;
      case VAR_INSN:
        sb.append(' ');
        sb.append('#');
        sb.append(((VarInsnNode)ai).var);
        break;
      case TYPE_INSN:
        sb.append(' ');
        sb.append(((TypeInsnNode)ai).desc);
        break;
      case FIELD_INSN:
        FieldInsnNode fin = (FieldInsnNode)ai;
        sb.append(' ');
        sb.append(fin.owner);
        sb.append('.');
        sb.append(fin.name);
        sb.append(' ');
        sb.append(fin.desc);
        break;
      case METHOD_INSN:
        MethodInsnNode min = (MethodInsnNode)ai;
        sb.append(' ');
        sb.append(min.owner);
        sb.append('.');
        sb.append(min.name);
        sb.append(' ');
        sb.append(min.desc);
        break;
      case JUMP_INSN:
        break;
      case LDC_INSN:
        Object cst = ((LdcInsnNode)ai).cst;
        sb.append(' ');
        sb.append(cst.getClass().getName());
        sb.append(' ');
        sb.append(cst);
        break;
      case IINC_INSN:
        IincInsnNode iin = (IincInsnNode)ai;
        sb.append(' ');
        sb.append('#');
        sb.append(iin.var);
        sb.append(' ');
        sb.append(iin.incr);
        break;
      case TABLESWITCH_INSN:
        break;
      case LOOKUPSWITCH_INSN:
        break;
      case MULTIANEWARRAY_INSN:
        MultiANewArrayInsnNode m = (MultiANewArrayInsnNode)ai;
        sb.append(' ');
        sb.append(m.desc);
        sb.append(' ');
        sb.append(m.dims);
        break;
    }
    return sb.toString();
  }
}